<?php
	define("SHOW_ENABLED", true);		// true: HIS integration is enabled; false: disabled
	define("SHOW_DB", "BMP");		// PacsOne database
	define("SHOW_USER", "mduser");		// PacsOne user with view privileges
	define("SHOW_PASSWORD", "BMPmduser2012");	// user's password
	define("POLIS_HOST", "192.168.1.222");	// server IP address
	define("POLIS_USER", "pacs");		// username with SELECT privilege on table "asmenys"
	define("POLIS_PASSWORD", "Labas_456");	// password for POLIS_USER


	/* Requires to define supported request list */
	$supportedRequests = array('aid');


	function externalAuthentication()
	{
		global $authDB;

		if (isset($_SESSION['login_patient']) && ($_SESSION['login_patient'] != ""))
		{
			if (isset($_GET['aid']))
			{
				$patient = getPID((string) $_GET['aid'], $message, $fatal);
				if ($patient != $_SESSION['login_patient'])
				{
					$_SESSION['login_patient'] = $patient;
					$authDB->logoff();
				}
			}
			else
			{
				$authDB->logoff();
			}
		}
		else
		{
			if (isset($_GET['aid']))
			{
				$authDB->logoff();
			}
		}
/*
		if ($_SESSION['login_post_patient'] != "")
		{
			if (isset($_POST['aid']))
			{
				$patient = getPID((string) $_POST['aid'], $message, $fatal);
				if ($patient != $_SESSION['login_post_patient'])
				{
					$_SESSION['login_post_patient'] = $patient;
					$authDB->logoff();
				}
			}
			else
				$authDB->logoff();
		}
		else
			if (isset($_POST['aid']))
				$authDB->logoff();
*/
	}


	function externalLoginInfo(&$db, &$user, &$password)
	{
		$_SESSION['login_patient'] = "";
		$_SESSION['login_username'] = "";
		$_SESSION['login_usergroup'] = "";

		if (SHOW_ENABLED)
		{
			unset($_SESSION['login_patient']);
			unset($_SESSION['login_post_patient']);

			if (isset($_GET['aid']))
			{
				global $authDB, $audit;

				unset($_SESSION['aid']);

				$aid = (string) $_GET['aid'];
				$patient = getPID($aid, $message, $fatal);
				if ($patient == "")
				{
					$db = "";
					$user = "";
					$password = "";
					unset($_GET['aid']);
					$audit->log(false, "aid '$aid', " . $authDB->formatConnectDetails('', ''));
					$authDB->goHome(true, $message, $fatal, $aid, 'aid');
				}
				else
					if (!check_patient_uid($patient, $message, $fatal))
					{
						$db = "";
						$user = "";
						$password = "";
						unset($_GET['aid']);
						$audit->log(false, "aid '$aid', " . $authDB->formatConnectDetails('', ''));
						$authDB->goHome(true, $message, $fatal, $patient, 'patient');
					}
					else
						if ((isset($user)) && ($user == ""))
						{
							$db = SHOW_DB;
							$user = SHOW_USER;
							$password = SHOW_PASSWORD;
							$_SESSION['login_patient'] = $patient;
							$audit->log("SUCCESS, patient '$patient'", "aid '$aid'");
						}
				return;
			}

/*
			if (isset($_POST['aid']))
			{
				unset($_SESSION['aid']);

				$aid = (string) $_POST['aid'];

				$patient = getPID($aid, $message, $fatal);
				if ($patient == "")
				{
					global $authDB;

					$db = "";
					$user = "";
					$password = "";
					unset($_POST['aid']);
					$authDB->goHome(true, $message, $fatal, $aid, 'aid');
				}
				else
					if (!check_patient_uid($patient, $message, $fatal))
					{
						global $authDB;

						$db = "";
						$user = "";
						$password = "";
						unset($_POST['aid']);
						$authDB->goHome(true, $message, $fatal, $patient, 'patient');
					}
					else
						if ((isset($user)) && ($user == ""))
						{
							$db = SHOW_DB;
							$user = SHOW_USER;
							$password = SHOW_PASSWORD;
							$_SESSION['login_post_patient'] = $patient;
						}
				return;
			}
*/
		}
	}


	function externalPrivileges(&$privileges)
	{
		if (isset($_SESSION['login_patient']) && ($_SESSION['login_patient'] != ""))
		{
			//$privileges['controlbar'] = false;
			$privileges['username'] = "";
///			return;
		}
/*
		if ($_SESSION['login_post_patient'] != "")
		{
			//$privileges['controlbar'] = false;
			$privileges['username'] = "";
			return;
		}
*/

		if (isset($_SESSION['login_username']) && ($_SESSION['login_username'] != ""))
			$privileges['username'] = $_SESSION['login_username'];
		if (isset($_SESSION['login_usergroup']) && ($_SESSION['login_usergroup'] == "Administrators"))
			$privileges['useradministration'] = true;
		else
			$privileges['useradministration'] = false;
	}


	function externalActions(&$actions)
	{
		if (isset($_SESSION['login_patient']) && ($_SESSION['login_patient'] != ""))
		{
			$actions = array();
			$actions['action'] = "Show";
			$actions['option'] = "patient";
			$actions['entry'] = array();
			$actions['entry'][0] = $_SESSION['login_patient'];
			return;
		}
/*
		if ($_SESSION['login_post_patient'] != "")
		{
			$actions = array();
			$actions['action'] = "Show";
			$actions['option'] = "patient";
			$actions['entry'] = array();
			$actions['entry'][0] = $_SESSION['login_post_patient'];
			return;
		}
*/
	}


	function check_patient_uid($uid, &$err, &$fatal)
	{
		global $authDB;
		global $log;

		$err = '';
		$fatal = 0;

		if (!$authDB->connect(SHOW_DB, SHOW_USER, SHOW_PASSWORD))
		{
			$err = 'errorValidateConnect';
			$fatal = 1;
			return false;
		}
		$sql = "SELECT private FROM patient WHERE origid='" . addslashes($uid) . "'";
		$rs = $authDB->query($sql);
		if (!$rs)
		{
			$log->asErr("SQL error: '" . $authDB->getError() . "'");
			$err = 'errorValidateQuery';
			$fatal = 1;
			return false;
		}
		$row = $authDB->fetchNum($rs);
		if (!$row)
		{
			$err = 'errorObjNotFound';
			$fatal = 1;
			return false;
		}

		return true;
	}


	function getPID($aid, &$message, &$fatal)
	{
		global $log;
		$pid = "";

		if (!function_exists('sqlsrv_connect'))
			exit('The "sqlsrv" driver is missing');

		$link = sqlsrv_connect(POLIS_HOST, array('UID' => POLIS_USER, 'PWD' => POLIS_PASSWORD,
			'Database' => 'polis', 'LoginTimeout' => 5));
		if(!$link)
		{
			$msg = '';
			$e = sqlsrv_errors();
			foreach ($e as $err)
				$msg .= '[' . $err['SQLSTATE'] . '] (' . $err['code'] . ') ' . $err['message'] . "\n";
			$log->asErr(__FUNCTION__ . '/sqlsrv_connect: ' . trim($msg));
			$message = 'errorValidateConnect';
			$fatal = 2;
			return '';
		}

		$query = sqlsrv_query($link, "SELECT TOP 1 ASM_ID,ASM_AK,ASM_PAVARDE,ASM_VARDAS FROM asmenys WHERE ASM_ID='" .
			addslashes($aid) . "' ORDER BY ASM_ID");
		if (!$query)
		{
			$msg = '';
			$e = sqlsrv_errors();
			foreach ($e as $err)
				$msg .= '[' . $err['SQLSTATE'] . '] (' . $err['code'] . ') ' . $err['message'] . "\n";
			$log->asErr(__FUNCTION__ . '/sqlsrv_query: ' . trim($msg));
			$message = 'errorValidateQuery';
			$fatal = 1;
			return "";
		}

		$row = sqlsrv_fetch_array($query, SQLSRV_FETCH_NUMERIC);
		if ($row)
			$pid = $row[1];
		sqlsrv_free_stmt($query);
		if ($pid == '')
		{
			$message = 'errorObjNotFound';
			$fatal = 2;
		}

		return $pid;
	}
